extern void memory_emem_add_card(ememinitfunc cardinit, ememmapfunc cardmap);
extern void set_emem(ULO,ULO);
extern UBY emem[];
extern UBY dmem[];

extern void memorystart(void);  /* Code alignment label */
extern ULO wriorgadr;

extern ULO sprite_delay;

extern UBY *address_to_ptr(ULO address);
extern ULO config_memory_chipsize;
extern ULO config_memory_fastsize;
extern ULO config_memory_bogosize;
extern ULO config_memory_nokick;
extern ULO config_memory_kicksize;
extern UBY config_memory_kickname[];
extern UBY config_memory_kicknameloaded[];
extern ULO config_memory_romversion;
extern char kickstart_idstring[80];
extern char *rom_identify(char *s);
extern char config_memory_keyname[];

extern ULO vgareg2color[256];

extern ULO screenptr;

extern ULO fetb(ULO adress);
extern ULO fetw(ULO adress);
extern ULO fetl(ULO adress);

extern void wrib(ULO data,ULO adress);
extern void wriw(ULO data,ULO adress);
extern void wril(ULO data,ULO adress);
extern char *memory_bank_pointers[256];
extern void dumpioblock(void);
extern ULO memory_init(void);
extern void hexdump(ULO);
extern void mem_initcolortranslation(void);
extern ULO dmaconr,dmacon;
extern ULO intenar,intena,intreq;
extern ULO potgor;


extern ULO lineflags[314];
/* Screen related registers */

extern ULO lof,xpos,ypos,diwxleft,diwxright,diwytop,diwybottom,ddfstrt,ddfstrtl,
    ddfstop,ddfstopl,topbottomflag,bpl1pt,bpl2pt,bpl3pt,bpl4pt,bpl5pt,bpl6pt,
    bplcon0,bplcon1,bplcon2,bpl1mod,bpl2mod,diwstrt,diwstop;

extern ULO DDFstartpos,DDFnumberofwords,DIWfirstvisiblepos,DIWlastvisiblepos;
extern ULO pagenr;

extern ULO adcon;

extern ULO dskpt,dsklen,dsksync;

/* Copper registers */

extern ULO copcon,cop1lc,cop2lc;

/* Blitter registers */

extern ULO linenum,linecount,linelength,blitterdmawaiting;

extern UBY cmem[];
extern UBY fmem[];
extern UBY bmem[];
extern UBY kmem[];


extern ULO sprpt[8],sprx[8],spry[8],sprly[8],spratt[8];
extern ULO spritestate[8];
extern ULO sprite16col[8];
extern UWO sprdat[8][2];

extern ULO oddscroll,evenscroll;
extern ULO oddhiscroll,evenhiscroll;

extern void dsetb(UBY data);
extern void dsetw(UWO data);
extern void dsetl(ULO data);
extern void dmem_setcounter(ULO val);
extern ULO dmem_getcounter(void);
extern void dmem_clear(void);

extern void memory_bank_set(readfunc rb, readfunc rw, readfunc rl,
			    writefunc wb, writefunc ww, writefunc wl,
			    char *basep, ULO bank, ULO basebank);


extern regreadfunc ioread[256];
extern regwritefunc iowrite[256];

extern void wintreq(ULO,ULO);

