// Variables for 4 disks
// -------------------

extern ULO sel[4],track[4],writeprot[4],dir[4],motor[4],side[4],enabled[4];
extern ULO inserted[4],active[4];
extern UBY image[4][901120];

extern UBY *diskinmem[4];
extern ULO inmemlasttrack[4];
extern ULO inmemtimesused[4];

/* Gzip stuff */

extern ULO gzserialno;
extern UBY gzipped[4];
extern char gzorgname[4][256];

/* Data to control the end of a transfer */

extern ULO diskdmainprogress;
extern ULO diskdmaen;   /* Counts the number of writes to dsklen */

extern void disk_reinsertImages(void);
extern void disk_init(void);
extern void insert_diskimage(char *diskname,ULO drive);

extern ULO diskimagestatus[4];

extern ULO config_floppy_fast;
extern char config_floppy_name[4][256];
extern ULO config_floppy_enabled[4];

extern void freeadfcache(void);
extern void disk_initstate(void);

extern void remove_gzip_image(int,int);
extern void copy_bootblock(void);

extern int floppy_drive_get_selected(void);
extern int floppy_drive_is_track0(int drive);
extern int floppy_drive_is_writeprotected(int drive);
extern int floppy_drive_is_ready(int drive);
extern int floppy_drive_is_changed(int drive);
extern void floppy_set_sel(ULO selbits);
extern void floppy_set_motor(ULO mtr);
extern void floppy_set_side(ULO s);
extern void floppy_set_dir(ULO dr);
extern void floppy_set_step(ULO stp);

